

import java.applet.Applet;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import javax.swing.*;



class ImageComponent extends Component implements ImageObserver{

  BufferedImage renderedImage = null ;
  
  private boolean repaintDone;

  public ImageComponent(BufferedImage start) {
    renderedImage =start ;
  }

  public BufferedImage swapImage(BufferedImage bi) {
    BufferedImage ret = renderedImage ;
    renderedImage = bi ;
    return ret ;
  }
  
  public void paintBlack(){
    Graphics g = getGraphics();
    g.setColor(Color.BLACK);
    g.fillRect(0,0,getWidth(),getHeight());
    g.dispose();
    repaint();
  }
  
  public boolean imageUpdate (Image image, int infoFlags,
      int x, int y, int width, int height)
    {
    System.out.println("obs");
      // Si le chargement est termin?, redessin de l'applet
      if ((infoFlags & ALLBITS) != 0)
      {
        repaintDone = true;
        repaint ();
        }
      return (infoFlags & (ALLBITS | ABORT)) == 0;
    }

  

  public void paint(Graphics g) {
    
    repaintDone = false;
    
    if (renderedImage != null) {
      BufferedImage bi = new BufferedImage(getWidth(),getHeight(),BufferedImage.TYPE_INT_RGB);
      Graphics g1 = bi.createGraphics();
      g1.setColor(Color.BLACK);
      //g1.fillRect(0,0,renderedImage.getWidth(),renderedImage.getHeight());
      g1.drawImage(renderedImage,0,0,this);

      
      g1.dispose();
      

    
      //((Graphics2D)g).drawImage(bi, new AffineTransform(1f,0f,0f,1f,0,0), this);
      g.drawImage(bi, 0, 0, this);
      //Image image2 = new ImageIcon(bi).getImage();
      //while(!repaintDone){};
      
      try{
        Thread.sleep(1);
      } catch (Exception e) {

      }

    }
  }
  
  public void update(Graphics g)  //surcharge indispensable
  {  paint(g);}

}


public class GraphicsWrapper {

  private int h = 0;
  private int w = 0;
  private int pixelSize = 0;

  //private JFrame  myFrame ;

  

  private BufferedImage drawingImage = null ;
  
  
  private void init() {
    drawingImage = new BufferedImage(w * pixelSize, h * pixelSize, BufferedImage.TYPE_INT_ARGB) ;

    BufferedImage start_with = new BufferedImage(w * pixelSize, h * pixelSize, BufferedImage.TYPE_3BYTE_BGR) ;

    
    Renderer3D.drawComp = new ImageComponent(  start_with ) ;
    //drawComp.setSize(new Dimension(w * pixelSize, h * pixelSize)) ;
    //Renderer3D.drawComp.setSize(800,600);
    Renderer3D.drawComp.setVisible(true) ;

    /*
    myFrame = new JFrame("Do-It-Yourself Renderer (TSI)");
    myFrame.setSize(800,600);
    myFrame.setSize(w * pixelSize, h * pixelSize);
    System.out.println(""+w*pixelSize);
    myFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE) ;
    myFrame.getContentPane().add("Center", Renderer3D.drawComp );
    myFrame.pack();
    myFrame.setVisible(true);
    */
  }
  /**
   * Build a virtual screen of size  w x h
   * And set its window visible.
   */
  public GraphicsWrapper(int w_, int h_) {
    this.h = h_;
    this.w = w_;
    this.pixelSize = 1 ;
    init();
  }
  /**
   * Build a virtual screen of size  w x h, where one virtual pixel is represented by
   * a 'pixel_size x pixel_size' square
   * And set its window visible.
   */
  public GraphicsWrapper(int w_, int h_, int pixel_size) {
    this.h = h_;
    this.w = w_;
    this.pixelSize = pixel_size ;
    init();
  }

  /**
   * Draw pixel x,y (in [0,w-1]x[0,h-1]) with color r,g,b (in [0,1]^3)
   * on the current draw buffer.
   */
  public void setPixel(int x, int y, double r, double g, double b)
    throws Exception
  {
    if ( 
        (! (0.0 <= r && r <= 1.0) ) || 
        (! (0.0 <= g && g <= 1.0) ) || 
        (! (0.0 <= b && b <= 1.0) ) ) {
      throw new Exception("Color param must be in [0 ; 1], here found: (" + r +
          ", " + g + ", " + b + ")" );
    }
    setPixel(x, y, (char) (r * 255), (char) (g * 255), (char) (b * 255));
  }
  /**
   * Draw pixel x,y (in [0,w-1]x[0,h-1]) with color r,g,b (in [|0,255|]^3)
   * on the current draw buffer.
   */
  public void setPixel(int x, int y, char r, char g, char b) {
    int argb = 0xFF000000 ;
    argb += ((int)r) << (8 * 2) ;
    argb += ((int)g) << (8 * 1) ;
    argb += ((int)b);
    try {
      for (int i = 0 ; i < pixelSize ; i++ ) {
        for (int j = 0 ; j < pixelSize ; j++ ) {
          drawingImage.setRGB(i + (x * pixelSize) , j + (y * pixelSize),  argb) ;
        }
      }
    } catch (java.lang.ArrayIndexOutOfBoundsException e) {
      System.out.println("SetPixel("+ x + ", " + y +") failed: " + e);
      throw e;
    }
  }

  /**
   * Clear current draw-buffer (ie Paint it black)
   *
   */
  public void clearBuffer() {
    Graphics2D gd = drawingImage.createGraphics();
    gd.setColor(Color.BLACK) ;
    gd.fillRect(0,0, w * pixelSize,h * pixelSize) ;
  }

  /**
   * Draw current draw-buffer on the window.
   *
   */
  public void swapBuffers() {
    //BufferedImage = drawingImage.

    
    Renderer3D.drawComp.swapImage(drawingImage) ;


    
    //myFrame.repaint();
    //Renderer3D.r3d.repaint() ;
    Renderer3D.r3d.repaintDrawComp();

    try{
      //Even with double buffering, there's 
      //still some flickering...
      Thread.sleep(10);
    } catch (Exception e){
      e.printStackTrace();
    }
    
  }
  


  /**
   * Destroy window.
   */
  public void destroy() {
    //myFrame.dispose();
  }
}
